// (CVN) - Candy Valley Network GmbH

#include "Adapters/LovenseConnectDesktopAdapter.h"

// EXTERNAL INCLUDES
#include <HttpModule.h>
#include <IHttpRequest.h>

// INTERNAL INCLUDES
#include "LovenseToy.h"


LovenseConnectDesktopAdapter::LovenseConnectDesktopAdapter()
	: LovenseConnectAdapterBase() {}

FHttpRequestPtr LovenseConnectDesktopAdapter::CreateHTTPRequest_GetToys() {
	FHttpRequestPtr httpRequest = FHttpModule::Get().CreateRequest();
#if WITH_LOVENSE
	httpRequest->SetVerb(TEXT("GET"));
	httpRequest->SetURL(FString::Printf(TEXT("%s://%s:%d/GetToys"), *this->webProtocol, *this->deviceIp, this->adapterDescription.httpsPort));
#endif
	return httpRequest;
}

FHttpRequestPtr LovenseConnectDesktopAdapter::CreateHTTPRequest_SendCommand(const FString& command) {
	FHttpRequestPtr httpRequest = FHttpModule::Get().CreateRequest();
#if WITH_LOVENSE
	httpRequest->SetVerb(TEXT("POST"));
	httpRequest->SetHeader("Content-Type", "application/json");
	//TArray<uint8> RawData;
	//FTCHARToUTF8 Converter(command);
	//RawData.Append(reinterpret_cast<const uint8*>(Converter.Get()), Converter.Length());

	httpRequest->SetURL(FString::Printf(TEXT("%s://%s:%d/command"), *this->webProtocol, *this->deviceIp, this->adapterDescription.httpsPort));
	// ֽݷ RawBodyData
	httpRequest->SetContentAsString(command);
#endif
	return httpRequest;
}
