// (CVN) - Candy Valley Network GmbH

#include "Adapters/LovenseConnectMobileAdapter.h"

// EXTERNAL INCLUDES
#include <HttpModule.h>
#include <IHttpRequest.h>

// INTERNAL INCLUDES
#include "LovenseManager.h"


LovenseConnectMobileAdapter::LovenseConnectMobileAdapter()
	: LovenseConnectAdapterBase() {}

FHttpRequestPtr LovenseConnectMobileAdapter::CreateHTTPRequest_GetToys() {
	FHttpRequestPtr httpRequest = FHttpModule::Get().CreateRequest();
#if WITH_LOVENSE
	httpRequest->SetVerb(this->GetVerb());
	httpRequest->SetURL(FString::Printf(TEXT("%s://%s:%d/GetToys"), *this->webProtocol, *this->deviceIp, this->adapterDescription.httpsPort));
#endif
	return httpRequest;
}

FHttpRequestPtr LovenseConnectMobileAdapter::CreateHTTPRequest_SendCommand(const FString& command) {
	FHttpRequestPtr httpRequest = FHttpModule::Get().CreateRequest();
#if WITH_LOVENSE
	httpRequest->SetVerb(this->GetVerb());
	httpRequest->SetURL(FString::Printf(TEXT("%s://%s:%d/%s"), *this->webProtocol, *this->deviceIp, this->adapterDescription.httpsPort, *command));
#endif
	return httpRequest;
}
